
#include "objects.h"
#include "unix.h"
#include "x.h"
#include "xt.h"
#include "externs.h"
#include <sys/time.h>

void readCylinderValues();
int checkCylinderValues();
extern ObjectStruct ObjectValues;

#define ASCIITEXTATTRIBUTES \
    XtNeditType, XawtextEdit, \
    XtNtype, XawAsciiString, \
    XtNuseStringInPlace, True, \
    XtNresizable, True, \
    XtNresize, XawtextResizeWidth, \
    XtNright, XtChainRight,


typedef struct _Text {
    char *filetext;
    char *textC;
    char *text1, *text2, *text3,
    *text4, *text5, *text6;
} 
Text, *TextPtr;


typedef struct _Widg {
    Widget cl, tp, bt;
} 
Widg, *WidgPtr;


typedef struct _Pass {
    TextPtr text;
    WidgPtr widg;
} 
Pass, *PassPtr;


/*
 *   Function Name: getOFFValues
 *   Description: Creates and pops up the Dialog widget to ask for a new
 *                input values
 *   Arguments: w - the command button that activated this function.
 *   Returns: none.
 */

void
generateCylinder( toplevel )
Widget toplevel;
{
    TextPtr   text = (TextPtr) malloc( sizeof (Text) );
    WidgPtr   widg = (WidgPtr) malloc( sizeof (Widg) );
    PassPtr   pass = (PassPtr) malloc( sizeof (Pass) );

    Widget    g_popup, g_form;
    Widget    g_label0, g_filelabel, g_filetext;
    Widget    g_label1, g_label3, g_label4, g_label5, g_label6,
              g_label7, g_label8, g_label9;
    Widget    g_text1, g_text3, g_text4, g_text5, g_text6,
              g_toggle7, g_toggle8, g_toggle9;
    Widget    g_label000, g_label001, g_label002;
    Widget    g_labelC, g_textC;
    Widget    g_labelx, g_labely, g_labelz;
    Widget    g_ok, g_cancel;
    Widget    g_title1, g_title2;

    Position x, y;

    char   string[20];
    String buffer;

    struct timeval tp;
    struct timezone tzp;

    static XtCallbackRec callbacks[] =
    {
        {(XtCallbackProc) NULL, (XtPointer) NULL},
        {(XtCallbackProc) NULL, (XtPointer) NULL},
    };

    ObjectValues.Obj.Cylinder.xaxis = 1.0;
    ObjectValues.Obj.Cylinder.yaxis = 1.0;
    ObjectValues.Obj.Cylinder.zaxis = 1.0;
    ObjectValues.Obj.Cylinder.depth = 3;
    ObjectValues.Obj.Cylinder.center.x = 0.0;
    ObjectValues.Obj.Cylinder.center.y = 0.0;
    ObjectValues.Obj.Cylinder.center.z = 0.0;
    ObjectValues.Obj.Cylinder.clockwise = False;
    ObjectValues.Obj.Cylinder.top = False;
    ObjectValues.Obj.Cylinder.bottom = False;

    map_dialog(toplevel, &x, &y);
    g_popup = XtVaCreatePopupShell( "Get Values",
        transientShellWidgetClass, toplevel,
        XtNx, x, XtNy, y,
        NULL );

    g_form = XtVaCreateManagedWidget( "g_form", formWidgetClass, g_popup,
        NULL );

    sprintf( string, "Object : Cylinder" );
    g_label0 = XtVaCreateManagedWidget( "g_label0", labelWidgetClass, g_form,
        XtNlabel, string,
        NULL );

    gettimeofday( &tp, &tzp );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "cylinder_%d.geom", (tp.tv_sec)%1000 );
    text->filetext = XtNewString( buffer );
    g_filelabel = XtVaCreateManagedWidget( "g_filelabel", labelWidgetClass,
        g_form,
        XtNfromVert, g_label0,
        NULL );
    g_filetext = XtVaCreateManagedWidget( "g_filetext", asciiTextWidgetClass,
        g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->filetext,
        XtNlength, 30,
        XtNwidth, 11*strlen(buffer),
        XtNinsertPosition, strlen(buffer),
        XtNfromVert, g_label0,
        XtNfromHoriz, g_filelabel,
        NULL );

    g_label000 = XtVaCreateManagedWidget( "g_label000", labelWidgetClass,g_form,
        XtNfromVert, g_filelabel,
        NULL );

    g_title1 = XtVaCreateManagedWidget( "g_title1", labelWidgetClass, g_form,
        XtNfromVert, g_label000,
        NULL );

    g_labelC  = XtVaCreateManagedWidget( "g_labelC", labelWidgetClass, g_form,
        XtNwidth, 10*7,
        XtNfromVert, g_title1,
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f %.2f %.2f", ObjectValues.Obj.Cylinder.center.x,
        ObjectValues.Obj.Cylinder.center.y, ObjectValues.Obj.Cylinder.center.z );
    text->textC = XtNewString( buffer );
    g_textC = XtVaCreateManagedWidget( "g_textC", asciiTextWidgetClass,
        g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->textC,
        XtNlength, 25,
        XtNwidth, 11*strlen(text->textC),
        XtNinsertPosition, strlen(text->textC),
        XtNfromVert, g_title1,
        XtNfromHoriz, g_labelC,
        NULL );

    g_label4 = XtVaCreateManagedWidget( "g_label4", labelWidgetClass, g_form,
        XtNwidth, 10*7,
        XtNfromVert, g_labelC,
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f", ObjectValues.Obj.Cylinder.xaxis );
    text->text4 = XtNewString( buffer );
    g_text4  = XtVaCreateManagedWidget( "g_text4", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text4,
        XtNlength, 5,
        XtNinsertPosition, strlen(text->text4),
        XtNfromVert, g_labelC,
        XtNfromHoriz, g_label4,
        NULL );

    g_label5 = XtVaCreateManagedWidget( "g_label5", labelWidgetClass, g_form,
        XtNwidth, 10*7,
        XtNfromVert, g_label4,
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f", ObjectValues.Obj.Cylinder.yaxis );
    text->text5 = XtNewString( buffer );
    g_text5  = XtVaCreateManagedWidget( "g_text5", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text5,
        XtNlength, 5,
        XtNinsertPosition, strlen(text->text5),
        XtNfromVert, g_label4,
        XtNfromHoriz, g_label5,
        NULL );

    g_label6 = XtVaCreateManagedWidget( "g_label6", labelWidgetClass, g_form,
        XtNwidth, 10*7,
        XtNfromVert, g_label5,
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f", ObjectValues.Obj.Cylinder.zaxis );
    text->text6 = XtNewString( buffer );
    g_text6  = XtVaCreateManagedWidget( "g_text6", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text6,
        XtNlength, 5,
        XtNinsertPosition, strlen(text->text6),
        XtNfromVert, g_label5,
        XtNfromHoriz, g_label6,
        NULL );

    g_label1 = XtVaCreateManagedWidget( "g_label1", labelWidgetClass, g_form,
        XtNwidth, 10*7,
        XtNfromVert, g_label6,
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%d", ObjectValues.Obj.Cylinder.depth );
    text->text1 = XtNewString( buffer );
    g_text1  = XtVaCreateManagedWidget( "g_text1", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text1,
        XtNlength, 1,
        XtNinsertPosition, strlen(text->text1),
        XtNfromVert, g_label6,
        XtNfromHoriz, g_label1,
        NULL );

    g_label001 = XtVaCreateManagedWidget( "g_label001", labelWidgetClass,g_form,
        XtNfromVert, g_label1,
        NULL );

    g_title2 = XtVaCreateManagedWidget( "g_title2", labelWidgetClass, g_form,
        XtNfromVert, g_label001,
        NULL );
    g_label7 = XtVaCreateManagedWidget( "g_label7", labelWidgetClass, g_form,
        XtNfromVert, g_title2,
        NULL );
    callbacks[0].callback = (XtCallbackProc) changeSign;
    callbacks[0].closure  = (XtPointer) NULL;
    g_toggle7  = XtVaCreateManagedWidget( "g_toggle7", toggleWidgetClass,g_form,
        XtNcallback, callbacks,
        XtNfromVert, g_title2,
        XtNfromHoriz, g_label7,
        NULL );
    if( ObjectValues.Obj.Cylinder.clockwise )
        XtVaSetValues( g_toggle7, XtNlabel, "+", NULL );
    else
        XtVaSetValues( g_toggle7, XtNlabel, "-", NULL );

    g_label8 = XtVaCreateManagedWidget( "g_label8", labelWidgetClass, g_form,
        XtNfromVert, g_label7,
        NULL );
    callbacks[0].callback = (XtCallbackProc) changeSign;
    callbacks[0].closure  = (XtPointer) NULL;
    g_toggle8  = XtVaCreateManagedWidget( "g_toggle8", toggleWidgetClass,g_form,
        XtNcallback, callbacks,
        XtNfromVert, g_label7,
        XtNfromHoriz, g_label8,
        NULL );
    if( ObjectValues.Obj.Cylinder.top )
        XtVaSetValues( g_toggle8, XtNlabel, "+", NULL );
    else
        XtVaSetValues( g_toggle8, XtNlabel, "-", NULL );

    g_label9 = XtVaCreateManagedWidget( "g_label9", labelWidgetClass, g_form,
        XtNfromVert, g_label8,
        NULL );
    callbacks[0].callback = (XtCallbackProc) changeSign;
    callbacks[0].closure  = (XtPointer) NULL;
    g_toggle9  = XtVaCreateManagedWidget( "g_toggle9", toggleWidgetClass,g_form,
        XtNcallback, callbacks,
        XtNfromVert, g_label8,
        XtNfromHoriz, g_label9,
        NULL );
    if( ObjectValues.Obj.Cylinder.bottom )
        XtVaSetValues( g_toggle9, XtNlabel, "+", NULL );
    else
        XtVaSetValues( g_toggle9, XtNlabel, "-", NULL );

    g_label002 = XtVaCreateManagedWidget( "g_label002", labelWidgetClass,g_form,
        XtNfromVert, g_label9,
        NULL );

    widg->cl = g_toggle7;
    widg->tp = g_toggle8;
    widg->bt = g_toggle9;
    pass->text = text;
    pass->widg = widg;

    callbacks[0].callback = (XtCallbackProc) readCylinderValues;
    callbacks[0].closure  = (XtPointer) pass;
    g_ok = XtVaCreateManagedWidget( "g_ok", commandWidgetClass, g_form,
        XtNcallback, callbacks,
        XtNfromVert, g_label002,
        NULL );

    callbacks[0].callback = (XtCallbackProc) DestroyPopupPrompt;
    callbacks[0].closure  = (XtPointer) g_popup;
    g_cancel = XtVaCreateManagedWidget( "g_cancel", commandWidgetClass, g_form,
        XtNcallback, callbacks,
        XtNfromVert, g_label002,
        XtNfromHoriz, g_ok,
        NULL );

/*
    XtRealizeWidget( g_popup );
*/
    XtPopup( g_popup, XtGrabNone );
    XMapRaised( XtDisplay( g_popup ), XtWindow( XtParent( g_popup ) ) );
}


static void
changeSign( widget, client_data, call_data )
Widget widget;
XtPointer call_data, client_data;
{
    Boolean state;

    XtVaGetValues( widget, XtNstate, &state, NULL );
    if( state ) XtVaSetValues( widget, XtNlabel, "+", NULL );
    if( !state ) XtVaSetValues( widget, XtNlabel, "-", NULL );
}


static void
DestroyPopupPrompt( widget, client_data, call_data )
Widget widget;
XtPointer call_data, client_data;
{
    Widget popup = (Widget)client_data;
    extern char creatingObject;
    creatingObject = False;
    XtPopdown( popup );
    XtDestroyWidget( popup );
}


void
readCylinderValues( widget, client_data, call_data )
Widget widget;
XtPointer client_data, call_data;
{
    Widget popup = XtParent( XtParent( widget ) );
    PassPtr pass = (PassPtr) client_data;
    WidgPtr pwidg = (WidgPtr) pass->widg;
    TextPtr ptext = (TextPtr) pass->text;
    extern char creatingObject;

    float xaxis, yaxis, zaxis;
    int depth;
    Point center;
    Boolean clockwise, top, bottom;
    Status status;
    int primitive=0;

    extern String filename;

    filename = (String) malloc( strlen((const char *)getenv("OBJ_PATH")) + 80 );

    strcat( strcat( strcpy( filename, (const char *)getenv("OBJ_PATH") ), "/" ), ptext->filetext );
    sscanf( ptext->textC, "%f %f %f", &(center.x), &(center.y), &(center.z) );
    XtFree( ptext->textC );
    sscanf( ptext->text1, "%d", &depth );
    XtFree( ptext->text1 );
    sscanf( ptext->text4, "%f", &xaxis );
    XtFree( ptext->text4 );
    sscanf( ptext->text5, "%f", &yaxis );
    XtFree( ptext->text5 );
    sscanf( ptext->text6, "%f", &zaxis );
    XtFree( ptext->text6 );
    XtVaGetValues( pwidg->cl, XtNstate, &clockwise, NULL );
    XtVaGetValues( pwidg->tp, XtNstate, &top, NULL );
    XtVaGetValues( pwidg->bt, XtNstate, &bottom, NULL );

    ObjectValues.Obj.Cylinder.xaxis = xaxis;
    ObjectValues.Obj.Cylinder.yaxis = yaxis;
    ObjectValues.Obj.Cylinder.zaxis = zaxis;
    ObjectValues.Obj.Cylinder.depth = depth;
    ObjectValues.Obj.Cylinder.center.x = center.x;
    ObjectValues.Obj.Cylinder.center.y = center.y;
    ObjectValues.Obj.Cylinder.center.z = center.z;
    ObjectValues.Obj.Cylinder.clockwise = clockwise;
    ObjectValues.Obj.Cylinder.top = top;
    ObjectValues.Obj.Cylinder.bottom = bottom;

    if( !(status = checkCylinderValues( popup, xaxis, yaxis, zaxis, depth ) ) )
        Cylinder( xaxis, yaxis, zaxis, center, depth,
            clockwise, top, bottom, primitive );

    creatingObject = False;
    XtPopdown( popup );
    XtDestroyWidget( popup );
}


int
checkCylinderValues( w, xaxis, yaxis, zaxis, depth )
Widget w;
float xaxis, yaxis, zaxis;
int depth;
{
    char buffer[80];
    int errors = 0;

    if( depth < 1 || depth > 7 ) {
        sprintf( buffer, "Error -- Required Condition: 1 <= depth(%d) <= 7\n",
            depth );
        message( w, buffer );
        errors++;
    }
    if( NEAR_ZERO( xaxis ) ) {
        sprintf( buffer, "Error -- Required Condition: xaxis(%.2f) > 0.0\n",
            xaxis );
        message( w, buffer );
        errors++;
    }
    if( NEAR_ZERO( yaxis ) ) {
        sprintf( buffer, "Error -- Required Condition: yaxis(%.2f) > 0.0\n",
            yaxis );
        message( w, buffer );
        errors++;
    }
    if( NEAR_ZERO( zaxis ) ) {
        sprintf( buffer, "Error -- Required Condition: zaxis(%.2f) > 0.0\n",
            zaxis );
        message( w, buffer );
        errors++;
    }
    return errors;
}
